#include "A_Globals.au3"

#cs
Fonction Load. Debut du programme.
Creation des fichiers index  + config
Reindexation => 3 tableaux trier
$File_index[x][0] Tous les fichiers.
$File_index[x][1] Fichier pour recherche dans les fichiers	
$File_index[x][2] Fichier filtrs
$File_index[x][3] Fichier Filtrs  + recherche
#ce
Func _load()
	if not FileExists(@scriptdir & "\fil.exe") then fileinstall("E:\Programmation\Autoit3\Ariane\fil.exe",@ScriptDir & "\fil.exe")
	If Not FileExists(@ScriptDir & "\index.txt") Then
		$answer = MsgBox(324, "Fichier manquant:", "Le fichier 'index.txt' n'a pas t trouv. Voulez vous faire une indexation ?")
		If $answer = 6 Then
			$folder_to_index = FileSelectFolder("Choississez un repertoire  indexer", "c:/")
			If @error Then Exit MsgBox(16, "Erreur", "Vous devez procder  une indexation pour pouvoir utiliser Ariane !")
			$folder_to_index = StringReplace($folder_to_index, "\", "/")
			If StringRight($folder_to_index, 1) <> '/'  Then $folder_to_index = $folder_to_index & "/"
			$OPT_PATH=$folder_to_index
			index($OPT_PATH)
		Else
			Exit MsgBox(16, "Erreur", "Vous devez procder  une indexation pour pouvoir utiliser Ariane !")
		EndIf
	EndIf
	SplashOff()
	If FileGetSize(@ScriptDir & "\index.txt") = 0 Then Exit MsgBox(16, "Erreur", "Il semble que l'indexation est echou, veuillez changer de repertoire.")
	$file = FileOpen(@ScriptDir & "\index.txt", 0)
	$file_read = FileRead($file)
	$file_string_split = StringSplit($file_read, "")
	$file_string_split[0] = $file_string_split[0] - 1
	
	Dim $File_index[$file_string_split[0] + 1][4]
	For $i = 0 To $file_string_split[0]
		$File_index[$i][0] = $file_string_split[$i]
	Next

	If Not FileExists(@ScriptDir & "\config.ini") Then
		$answer = MsgBox(324, "Configuration:", "Ariane n'a trouv aucun fichier de configuration." & @CRLF & @CRLF & "Voulez vous configurer Ariane maintenant ?")
		If $answer = 6 Then
			FileWrite(@ScriptDir & "/config.ini", '')
			gui_option()
		EndIf
	Else
		$Filtre = string_filtre(IniRead(@ScriptDir & "\config.ini", "options", "Filtre", ""))
		$OPT_FILTRE = IniRead(@ScriptDir & "\config.ini", "options", "Opt_Filtre", "1")
		$OPT_IN_FILE = IniRead(@ScriptDir & "\config.ini", "options", "Opt_In_File", "0")
		$OPT_INDEX = IniRead(@ScriptDir & "\config.ini", "options", "Opt_Index", "0")
		$OPT_INDEX_JOUR = IniRead(@ScriptDir & "\config.ini", "options", "Opt_Index_Jour", "7")
		$OPT_PATH = IniRead(@ScriptDir & "\config.ini", "options", "Opt_Path", "")
		$OPT_LAST_INDEX=Iniread(@ScriptDir & "\config.ini", "options", "Opt_last_index","" )
	EndIf
	
	if $OPT_INDEX_JOUR > 0 and _DateIsValid($OPT_LAST_INDEX)  and $OPT_INDEX = 1 and _DateDiff('d',$OPT_LAST_INDEX,_NowCalcdate())>$OPT_INDEX_JOUR then 
		MsgBox(64,"Reindexation","La reindexation automatique c'est declenche..." & @CRLF & @CRLF & "Repertoire: " & $OPT_PATH)
		index( $OPT_PATH)
	endif
	Reindexation()
EndFunc   ;==>_load

Func Reindexation()
	V_progress("Ariane...", "Chargement des fichiers...", 0, 0)
	$offset_1 = 1
	$offset_2 = 1
	$offset_3 = 1
	For $i = 1 To $File_index[0][0]
		V_progress("Ariane...", "Chargement des fichiers..." & Round(100 * $i / $File_index[0][0]), 100 * $i / $File_index[0][0], 1)
		$data = StringSplit($File_index[$i][0], "|")
		If alow_read($data[3]) = 1 Then
			$File_index[$offset_1][1] = $File_index[$i][0]
			$offset_1 += 1
		EndIf
		If exclude($data[3]) = -1 Then
			$File_index[$offset_2][2] = $File_index[$i][0]
			$offset_2 += 1
		EndIf
		If alow_read($data[3]) And exclude($data[3]) = -1 Then
			$File_index[$offset_3][3] = $File_index[$i][0]
			$offset_3 += 1
		EndIf
	Next
	$File_index[0][1] = $offset_1 - 1
	$File_index[0][2] = $offset_2 - 1
	$File_index[0][3] = $offset_3 - 1
	V_progress("Ariane...", "Chargement des fichiers...", 0, 2)
EndFunc   ;==>Reindexation