#include"A_Globals.au3"
Func gui_option()
	WinSetTrans("Ariane", "", 0)
	$gui_option = GUICreate("Ariane: Options", 400, 380)
	GUICtrlCreateLabel("Version:" & $Version, 10, 360)
	GUICtrlSetFont(-1, 8)
	GUICtrlCreateLabel("VooDoo @07-08", 300, 360)
	GUICtrlSetFont(-1, 8)
	GUICtrlCreateTab(10, 10, 380, 350)
	$tab_general = GUICtrlCreateTabItem("General")
	GUICtrlCreateGroup("General", 20, 50, 360, 300)
	GUICtrlCreateLabel("Ici vous trouverez les options de demarrages d'Ariane. Pour plus d'information pointez votre souris sur l'option ! ", 40, 70, 340, 30)
	GUICtrlSetColor(-1, 0x00008B)
	$box_in_file = GUICtrlCreateCheckbox("Rechercher dans les fichiers", 70, 130)
	GUICtrlSetTip(-1, "Ariane recherchera dans les fichiers texte la saisie", "Infos:", 1, 5)
	$tab_filtre = GUICtrlCreateTabItem("Filtre")
	GUICtrlCreateGroup("Filtre", 20, 50, 360, 300)
	GUICtrlCreateLabel("les filtres vous permettre d'exclure un certains type de fichier dans les recherches d'Ariane", 40, 70, 340, 30)
	GUICtrlSetColor(-1, 0x00008B)
	$comb_filtre = GUICtrlCreateCombo("", 40, 110, 200, -1, $CBS_DROPDOWNLIST)
	$inp_filtre = GUICtrlCreateInput("", 40, 140, 200, 20)
	$but_del = GUICtrlCreateButton("Supprimer", 270, 110, 70, 20)
	$but_add = GUICtrlCreateButton("Ajouter", 270, 140, 70, 20)
	$box_filtre = GUICtrlCreateCheckbox("Activer les filtres", 70, 200)
	
	$tab_index = GUICtrlCreateTabItem("Indexation")
	GUICtrlCreateGroup("Indexation", 20, 50, 360, 300)
	GUICtrlCreateLabel("Choisissez votre mode d'indexation", 40, 70, 340, 30)
	GUICtrlSetColor(-1, 0x00008B)
	$rad_manuel = GUICtrlCreateRadio("Manuel", 40, 110)
	GUICtrlSetTip(-1, "La reindexation se fera  chaque fois que vous appuyerez sur le bouton 'Reindexer'", "Manuel:", 1, 5)
	$rad_auto = GUICtrlCreateRadio("Automatique", 40, 130)
	GUICtrlSetTip(-1, "Tous les X jours la reindexation se lancera", "Automatique:", 1, 5)
	$inp_auto_jour = GUICtrlCreateInput($OPT_INDEX_JOUR, 200, 160, 40, 20)
	GUICtrlCreateUpdown($inp_auto_jour)
	GUICtrlCreateLabel("Frequence de mise a jour:", 60, 150, 100, 100)
	GUICtrlSetFont(-1, 7, -1, 2)
	
	GUICtrlCreateLabel("Repertoire d'indexation", 40, 230, 340, 30)
	GUICtrlSetColor(-1, 0x00008B)
	$inp_path = GUICtrlCreateInput($OPT_PATH, 30, 270, 300, 20)
	$but_parcourir = GUICtrlCreateButton("Parcourir", 330, 270, 50, 20)
	$but_reindex = GUICtrlCreateButton("Reindexer", 30, 300, 300, 20)
	
	$data = ""
	For $i = 1 To $Filtre[0]
		$data &= "|" & $Filtre[$i]
	Next
	
	If $Filtre[0] > 0 Then GUICtrlSetData($comb_filtre, StringTrimLeft($data, 1), $Filtre[$Filtre[0]])
	
	If $OPT_FILTRE = 1 Then GUICtrlSetState($box_filtre, $GUI_CHECKED)
	If $OPT_IN_FILE = 1 Then GUICtrlSetState($box_in_file, $GUI_CHECKED)
	If $Filtre[0] = 0 Then GUICtrlSetState($box_filtre, $GUI_DISABLE)
	
	Switch $OPT_INDEX
		Case 0
			GUICtrlSetState($inp_auto_jour, $GUI_DISABLE)
			GUICtrlSetState($rad_manuel, $GUI_CHECKED)
		Case 1
			GUICtrlSetState($inp_auto_jour, $GUI_ENABLE)
			GUICtrlSetState($rad_auto, $GUI_CHECKED)
	EndSwitch
	
	$Change = 0
	GUISetState()
	While 1
		$msg = GUIGetMsg()
		Switch $msg
			Case $rad_auto
				$OPT_INDEX = 1
				GUICtrlSetState($inp_auto_jour, $GUI_ENABLE)
			Case $rad_manuel
				$OPT_INDEX = 0
				GUICtrlSetState($inp_auto_jour, $GUI_DISABLE)
			Case $box_in_file
				If GUICtrlRead($box_in_file) = $GUI_CHECKED Then
					$OPT_IN_FILE = 1
				Else
					$OPT_IN_FILE = 0
				EndIf
				
			Case $box_filtre
				If GUICtrlRead($box_filtre) = $GUI_CHECKED Then
					$OPT_FILTRE = 1
				Else
					$OPT_FILTRE = 0
				EndIf
				
			Case $but_add
				$Change = 1
				If $Filtre[0] = $MAX_NB_FILTRE Then ExitLoop MsgBox(16, "Erreur:", "Vous avez atteind le nombre maximum de filtres")
				
				If Not GUICtrlRead($inp_filtre) = '' Then
					If _ArraySearch($Filtre, GUICtrlRead($inp_filtre), 0, 0, 0, False) <> -1 And Not $Filtre[0] = 0 Then ContinueLoop MsgBox(16, "Erreur:", "Ce filtre est dj activ !")
					$Filtre[0] += 1
					$Filtre[$Filtre[0]] = GUICtrlRead($inp_filtre)
				EndIf
				GUICtrlSetData($comb_filtre, GUICtrlRead($inp_filtre), GUICtrlRead($inp_filtre))
				GUICtrlSetData($inp_filtre, '')
				If $Filtre[0] > 0 Then GUICtrlSetState($box_filtre, $GUI_ENABLE)
				
			Case $but_del
				$Change = 1
				$where = _ArraySearch($Filtre, GUICtrlRead($comb_filtre), 0, 0, 0, False)
				If $where = -1 Then Return
				_ArrayDelete($Filtre, $where)
				$Filtre[0] -= 1
				$data = ""
				For $i = 1 To $Filtre[0]
					$data &= "|" & $Filtre[$i]
				Next
				_GUICtrlComboBox_ResetContent($comb_filtre)
				If $Filtre[0] = 0 Then GUICtrlSetState($box_filtre, $GUI_DISABLE)
				If $Filtre[0] > 0 Then GUICtrlSetData($comb_filtre, StringTrimLeft($data, 1), $Filtre[$Filtre[0]])
				
			Case $but_parcourir
				$folder_to_index = FileSelectFolder("Choississez un repertoire  indexer", "c:/")
				$folder_to_index = StringReplace($folder_to_index, "\", "/")
				If StringRight($folder_to_index, 1) <> '/' Then $folder_to_index = $folder_to_index & "/"
				GUICtrlSetData($inp_path, $folder_to_index)
				
			Case $but_reindex
				$OPT_PATH = GUICtrlRead($inp_path)
				If $OPT_PATH = "" Then
					$folder_to_index = FileSelectFolder("Choississez un repertoire  indexer", "c:/")
					If @error Then Return MsgBox(16, "Erreur", "Vous devez procder  une indexation pour pouvoir utiliser Ariane !")
					$folder_to_index = StringReplace($folder_to_index, "\", "/")
					If StringRight($folder_to_index, 1) <> '/' Then $folder_to_index = $folder_to_index & "/"
					$OPT_PATH = $folder_to_index
				EndIf
				index($OPT_PATH)
				reindexation()
				
			Case $GUI_EVENT_CLOSE
				If $OPT_INDEX = 1 Then $OPT_INDEX_JOUR = GUICtrlRead($inp_auto_jour)
				If $OPT_INDEX_JOUR <= 0 and $OPT_INDEX=1 Then ContinueLoop MsgBox(16,"Erreur:","la frequence de mise  jour ne peut pas tre ngatif ou nulle !")
				$OPT_PATH = GUICtrlRead($inp_path)
				GUIDelete($gui_option)
				If $Change = 1 Then Reindexation()
				WinSetTrans("Ariane", "", 255)
				Return
				
		EndSwitch
	WEnd
EndFunc   ;==>gui_option